theory Test imports Main
begin

types
  ('t, 'a) parser = "'t list \<Rightarrow> string + ('a \<times> 't list)"

abbreviation 
  return :: "'a \<Rightarrow> ('t, 'a)parser"
where
  "return x \<equiv> (\<lambda>ts. Inr (x, ts))"

definition
  bind :: "('t, 'a) parser \<Rightarrow> ('a \<Rightarrow> ('t, 'b) parser) \<Rightarrow> ('t, 'b) parser"
where
  "bind m f ts = (case m ts of
      Inl e \<Rightarrow> Inl e
    | Inr (x,ts') \<Rightarrow> f x ts')"

fun consume :: "('t,'t)parser"
where "consume [] = Inl ''error''"
   |  "consume (t # ts) = return t ts"

function foo :: "('t, 't list)parser"
where "foo ts = (bind consume 
                   (\<lambda> t. bind foo
                   (\<lambda> us. bind foo
                   (\<lambda> vs. return (t # us @ vs))))) ts"
by pat_completeness auto
termination 
proof
(*  impossible, since there is no link between input ts and the list
    of tokens that is used for recursive foo-calls *)
oops


lemma bind_cong[fundef_cong]:
 fixes m1 :: "('t,'a)parser"
 assumes "m1 ts2 = m2 ts2"
 and "\<And> y ts. m2 ts2 = Inr (y,ts) ==> f1 y ts = f2 y ts"
 and "ts1 = ts2"
 shows "((bind m1 f1) ts1) = ((bind m2 f2) ts2)" 
using assms unfolding bind_def by (cases "m1 ts1", auto)

lemma bind_cong[fundef_cong]:
  fixes m1 :: "('t,'a)parser" 
  assumes "m1 ts1 = m2 ts1" and "\<And> y ts. m1 ts1 = Inr (y,ts) \<Longrightarrow> f1 y ts = f2 y ts" and "ts1 = ts2"
  shows "((bind m1 f1) ts1) = ((bind m2 f2) ts2)"


function foo' :: "('t, 't list)parser"
where "foo' ts = (bind consume 
                   (\<lambda> t. bind foo'
                   (\<lambda> vs. return (t # vs)))) ts"
by pat_completeness auto
termination
proof
  show "wf (measures[length])" by simp
next
  fix ts y tsa
  assume "consume ts = return y tsa"
  thus "(tsa, ts) \<in> measures [length]" 
    by (cases ts, auto simp: bind_def)
qed

function foo'' :: "('t, 't list)parser"
where "foo'' ts = (bind consume 
                   (\<lambda> t. bind foo''
                   (\<lambda> us. bind foo''
                   (\<lambda> vs. return (t # us @ vs))))) ts"
(*
exception THM 0 raised (line 709 of "thm.ML"): implies_elim: major premise
*)
by pat_completeness auto
termination
proof